#define _GNU_SOURCE
#include <fcntl.h> // O_WRONLY...
#include <stdio.h> // printf
#include <stdlib.h> // atoi
#include <string.h> // strcmp
#include <unistd.h> // close
#include <sys/wait.h> // wait
#include <time.h> // time
#include "pa23.h"
#include "internal.h"
#include "banking.h"
#include "collections.h"


typedef struct {
  int fd_write;
  int fd_read;
} __attribute__((packed)) pipe_fd;

typedef enum {
    ARGUMENTS_FORMAT_ERROR,
    OPEN_LOG_FILES_ERROR,
    FORK_ERROR,
    UNKNOWN_MESSAGE_TYPE_ERROR,
    SEND_MULTICAST_ERROR,
    RECEIVE_MULTICAST_TYPE_ERROR,
    UNEXPECTED_MESSAGE_TYPE_ERROR,
    TRANSFER_PARAMETERS_ERROR,
    DUPLICATED_STOP_MESSAGE_ERROR,
    EARLY_BALANCE_HISTORY_REQUEST_ERROR
} ErrorType;

typedef enum { 
	false, 
	true 
} bool;

typedef enum {
	LOG_STARTED,
	LOG_STARTED_RECIEVED_ALL,
	LOG_DONE,
	LOG_TRANSFER_OUT,
	LOG_TRANSFER_IN,
	LOG_DONE_RECIEVED_ALL
} EventLogType;

void pipe_work(local_id id, balance_t start_balance);
void parent_work();
int get_balances_count(int argc, char * argv[]);
int * get_balances(int accounts, char * argv[]);
void open_pipes();
void close_redundant_pipes(local_id id);
void close_self_pipes(local_id id);
void synchronize_other_start(local_id id, balance_t s_balance);
void computation(local_id id, int start_balance);
//void synchronize_other_done(local_id id);
int f_index(int i, int j);
pipe_fd * get_struct(int from, int to);
void log_error(int err_num);
int receive_multicast(local_id self, int16_t s_type);
void get_all_history_messages(AllHistory * all_history);
void send_history_message(local_id id, BalanceHistory *bh);
int send_multicast(void * self, const Message * msg);

// @param l_id    local process id
void log_event(int num_event, local_id l_id, local_id to_id, balance_t s_balance);

// @param num_event:
//  case 0: pipe_opend
//  case 1: pipe_closed
// @param from    local process id, that has write descriptor
// @param to      local process id, that has read descriptor
void log_pipe(int num_event, int from, int to);
void wait_children();
void check_history(AllHistory * all_history);
